/* ==================================================== ======== ======= *
 *
 *  uboxImpl.hh
 *  Ubit Project [Elc][2002]
 *  Author: Eric Lecolinet
 *
 *  Part of the Ubit Toolkit: A Brick Construction Game Model for Creating GUIs
 *
 *  (C) 1999-2002 Eric Lecolinet @ ENST Paris
 *  WWW: http://www.enst.fr/~elc/ubit   Email: elc@enst.fr (subject: ubit)
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************
 *
 * ==================================================== [Elc:02] ======= *
 * ==================================================== ======== ======= */

#ifndef _uboxImpl_hh
#define	_uboxImpl_hh
//pragma ident	"@(#)uboxImpl.hh	ubit:2.11.0"

// ====[internal implementation]===========================

class UBoxLink : public ULink {
  friend class UGroup;
  friend class UBox;
  friend class UWin;

  class UView* view_list;

public:
  UBoxLink(class UBox* box);

  // NOTE importante: ~UBoxLink ne detache PAS les liens !
  // normalement, c'est la fonction 'unlinkFromParent' appelee 
  // par 'remove' qui fait cela. 
  // Par contre ~UBoxLink() detruit les Views de ce lien.
  ~UBoxLink();
 
  // returns the View that is inside a given Parent View
  class UView* getViewInside(class UView* parent_view);
  class UView* getViewSize(class UView* parent_view, u_dim *w, u_dim *h);

  class UView* getViewList() {return view_list;}
  void addView(class UView*);

  void deleteRelatedViews(class UView* parent_view);
  static void deleteRelatedViews2(class UGroup*, class UView*);
};

#endif
/* ==================================================== [TheEnd] ======= */
/* ==================================================== [Elc:02] ======= */
