/* ==================================================== ======== ======= *
 *
 *  ucolorImpl.hh
 *  Ubit Project [Elc][2002]
 *  Author: Eric Lecolinet
 *
 *  Part of the Ubit Toolkit: A Brick Construction Game Model for Creating GUIs
 *
 *  (C) 1999-2002 Eric Lecolinet @ ENST Paris
 *  WWW: http://www.enst.fr/~elc/ubit   Email: elc@enst.fr (subject: ubit)
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************
 *
 * ==================================================== [Elc:02] ======= *
 * ==================================================== ======== ======= */

#ifndef _ucolorImpl_h
#define	_ucolorImpl_h
//pragma ident	"@(#)ucolor.hh	ubit:2.11.0"


class UColorImpl {
public:
  static const UX_Color UNDEF, NONE, INHERIT;

  UColorImpl(const char* colspec); // error if arg is null!
  UColorImpl(const char* colspec, UX_Color);
  ~UColorImpl();

  bool equals(const UColorImpl& ci2) const;

  void addRef() {refcount++;}
  void removeRef();
  u_count getRefCount() const {return refcount;}

private:
  friend class UColor;
  friend class UNatDisp;

  char *natspec;          // native ascii color spec.
  UX_Color* colors;
  unsigned short color_count;
  unsigned short refcount;
};


#endif
/* ==================================================== [TheEnd] ======= */
/* ==================================================== [Elc:02] ======= */

