/* ==================================================== ======== ======= *
 *
 *  uerror.hh
 *  Ubit Project  [Elc][2002]
 *  Author: Eric Lecolinet
 *
 *  Part of the Ubit Toolkit: A Brick Construction Game Model for Creating GUIs
 *
 *  (C) 1999-2002 Eric Lecolinet @ ENST Paris
 *  WWW: http://www.enst.fr/~elc/ubit   Email: elc@enst.fr (subject: ubit)
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************
 *
 * ==================================================== [Elc:02] ======= *
 * ==================================================== ======== ======= */

#ifndef _uerror_hh
#define	_uerror_hh
//pragma ident	"@(#)uerror.hh	ubit:2.11.0"


class UError {
  static void error(const char *classname, const char *funname, 
		    const char *errmsg, bool has_arg, const char* arg);
public:
  typedef const char* err_mesg;
  static err_mesg
    No_more_memory, 
    Null_argument,
    Null_or_invalid_argument,
    Null_arg_in_addlist,
    Warning_out_of_range_INT,
    Child_not_found_STR,
    Too_many_elements_INT,
    Unexpected_type_INT,
    Not_yet_implemented,

    Null_display,
    Unrealized_window,
    Cant_realize_window,
    Cant_realize_softwin,
    Cant_create_X_window,
    Cant_open_X_connection_STR,
    Invalid_X_screen_number,
    Null_external_X_window,

    Cant_realize_wingraph,
    Unbalanced_request_INT,
    Cant_retreive_font,
    Invalid_font_size,
    Unknown_color_STR,
    Full_colormap_STR,
    Null_colormap,

    Null_width_or_height,
    Incompatible_depths,
    Unrealized_image,
    Blending_requires_TrueColor,

    Cant_retreive_context,
    Cant_retreive_style,
    Cant_locate_source,
    Should_not_be_realized,
    Wrong_table_child_STR,
    Wrong_row_child_STR;

  static void error(const char *classname, const char *funname, 
		    const char *errmsg);
  static void error(const char *classname, const char *funname, 
		    const char *errmsg, long arg);
  static void error(const char *classname, const char *funname, 
		    const char *errmsg, const char* arg);
  static void error(const char *classname, const char *funname, 
		    const char *errmsg, const UStr& arg);
  static void error(const char *classname, const char *funname, 
		    const char *errmsg, const std::string& arg);
};
#endif
/* ==================================================== [TheEnd] ======= */
/* ==================================================== [Elc:02] ======= */
