/* ==================================================== ======== ======= *
 *
 *  umsproto.hh: UMS [Ubit Mouse Server] protocol
 *  Ubit Project  [Elc][2002]
 *  Author: Eric Lecolinet
 *
 *  Part of the Ubit Toolkit: A Brick Construction Game Model for Creating GUIs
 *
 *  (C) 1999-2002 Eric Lecolinet @ ENST Paris
 *  WWW: http://www.enst.fr/~elc/ubit   Email: elc@enst.fr (subject: ubit)
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************
 *
 * ==================================================== [Elc:02] ======= *
 * ==================================================== ======== ======= */

#ifndef _umsproto_hh
#define	_umsproto_hh
//pragma ident	"@(#)umsprotocol.hh	ubit:2.11.0"

struct UMS {
  enum Target {APPLI = -2, SERVER = -1, MOUSE0 = 0, MOUSE1 = 1};
  enum Ctrl {OPEN_CNX = 1, CLOSE_CNX = 2, OPEN_WIN = 3, CLOSE_WIN = 4, 
	     SEND_MESSAGE = 5, SEND_EVENT = 6};
};

struct UMSrequest {
  static const int MOUSE_SERVER_PORT = 45455;  // default port for mouse server
  static const int ARGS_SIZE = 20;

  // comm status
  enum Stat {Error = -1, CloseCnx = 0, Ok = 1, KeepCnx = 2};

  char ctrl;
  char target;
  char args[ARGS_SIZE];
};

#endif
/* ==================================================== [TheEnd] ======= */
/* ==================================================== [Elc:02] ======= */
