/* ==================================================== ======== ======= *
 *
 *  uwinImpl.hh
 *  Ubit Project  [Elc][2002]
 *  Author: Eric Lecolinet
 *
 *  Part of the Ubit Toolkit: A Brick Construction Game Model for Creating GUIs
 *
 *  (C) 1999-2002 Eric Lecolinet @ ENST Paris
 *  WWW: http://www.enst.fr/~elc/ubit   Email: elc@enst.fr (subject: ubit)
 *
 * ***********************************************************************
 * COPYRIGHT NOTICE : 
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY AND WITHOUT EVEN THE 
 * IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
 * YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER THE TERMS OF THE GNU 
 * GENERAL PUBLIC LICENSE AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
 * EITHER VERSION 2 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
 * SEE FILES 'COPYRIGHT' AND 'COPYING' FOR MORE DETAILS.
 * ***********************************************************************
 *
 * ==================================================== [Elc:02] ======= *
 * ==================================================== ======== ======= */

#ifndef _uwinImpl_hh
#define	_uwinImpl_hh
//pragma ident	"@(#)uwin.hh	ubit:2.8.1"
#include <uprop.hh>
#include <ugraph.hh>

/* ==================================================== ======== ======= */

class USoftwinImpl {
friend class UWin;
  UPos pos;
public:
  USoftwinImpl(UWin& win);
  ~USoftwinImpl();

protected:
  void update(const UUpdate& upmode, UWin*);
};

/* ==================================================== ======== ======= */

class UHardwinImpl {
  friend class UWin;
  friend class UNatWin;
  friend class USoftwinImpl;

  class UWinGraph& wingraph; 
  class ULink* sub_softwins;

public:
  UHardwinImpl(UWin& win);
  ~UHardwinImpl();

  class UWinGraph* getWinGraph() const {return &wingraph;} 
  class UNatWin*   getNatWin()   const {return wingraph.getNatWin();}

protected:
  void update(const class UUpdate &mode, UWin*);
  void updateImpl(const UUpdate& upmode, UWin* win,
		  bool impose_size, u_dim w, u_dim h);
};

#endif
/* ==================================================== [TheEnd] ======= */
/* ==================================================== [Elc:02] ======= */

